%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%    Copyright (C) 2004 Adam Spiro and Aharon Bar-Hillel
%    An implementation of a spike sorting algorithm according to the paper:
%    "Spike Sorting: Bayesian Clustering of Non-Stationary Data" 
%    by Aharon Bar-Hillel, Adam Spiro and Eran Stark 
%    (http://www.cs.huji.ac.il/~aharonbh/papers/SpikeSort_NIPS04.ps)
%
%    This program is free software; you can redistribute it and/or modify
%    it under the terms of the GNU General Public License as published by
%    the Free Software Foundation; either version 2 of the License, or
%    (at your option) any later version.
%
%    This program is distributed in the hope that it will be useful,
%    but WITHOUT ANY WARRANTY; without even the implied warranty of
%    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
%    GNU General Public License for more details.
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%


% plot spikes2 inner script : plots the spikes.

cm = colormap; % the color map

for i=1:maxColor
    inds=find(labels==i);
    if ~isempty(inds)
        avg_x = sum(data(inds,1))/size(inds,2);
        avg_y = sum(data(inds,2))/size(inds,2);
        % choose the color from the colormap which has 64 different colors.
        if i>1
            plot(data(inds,1),data(inds,2),'.','color',cm(floor(i*64/maxColor),:));
            h=text(avg_x,avg_y,int2str(i));
            set(h,'FontWeight','bold')
        else    % background model
            plot(data(inds,1),data(inds,2),'.k');  
        end
    end
end
axis equal;

axis([box])