%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%    Copyright (C) 2004 Adam Spiro and Aharon Bar-Hillel
%    An implementation of a spike sorting algorithm according to the paper:
%    "Spike Sorting: Bayesian Clustering of Non-Stationary Data" 
%    by Aharon Bar-Hillel, Adam Spiro and Eran Stark 
%    (http://www.cs.huji.ac.il/~aharonbh/papers/SpikeSort_NIPS04.ps)
%
%    This program is free software; you can redistribute it and/or modify
%    it under the terms of the GNU General Public License as published by
%    the Free Software Foundation; either version 2 of the License, or
%    (at your option) any later version.
%
%    This program is distributed in the hope that it will be useful,
%    but WITHOUT ANY WARRANTY; without even the implied warranty of
%    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
%    GNU General Public License for more details.
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

% This function plots several spike clustering offers, together with the 'true'
% solution and the 'on-line' solution.

% data -the data: (only first two dimensions used)
% groups - solution offers (label lists)
% optional :
% fig - a figure handle to draw in
% box- an axis
% titles - titles for the solution drawings

function present_clusterings2(data, labelings,fig,box,titles,GParams,maxCol)

if exist('fig')
    figure(fig);
    clf;
    hold on;
else
    f1=figure;
end

N=size(labelings,1);

sq=ceil(sqrt(N));

for j=1:N
    maxColor=maxCol(j);
    sb=subplot(sq,sq,j);
    hold on;
    labels=labelings(j,:);

    innerPlotScript;
    
    set(sb,'XTickLabel',[])
    set(sb,'YTickLabel',[])
    
    if exist('titles')
        title(titles{j});
    end
        
     if exist('box')==1
         axis([box])
     end
end
