%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%    Copyright (C) 2004 Adam Spiro and Aharon Bar-Hillel
%    An implementation of a spike sorting algorithm according to the paper:
%    "Spike Sorting: Bayesian Clustering of Non-Stationary Data" 
%    by Aharon Bar-Hillel, Adam Spiro and Eran Stark 
%    (http://www.cs.huji.ac.il/~aharonbh/papers/SpikeSort_NIPS04.ps)
%
%    This program is free software; you can redistribute it and/or modify
%    it under the terms of the GNU General Public License as published by
%    the Free Software Foundation; either version 2 of the License, or
%    (at your option) any later version.
%
%    This program is distributed in the hope that it will be useful,
%    but WITHOUT ANY WARRANTY; without even the implied warranty of
%    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
%    GNU General Public License for more details.
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
function [pLabels, pRecordGraph, pSolutions, pCorr, ppath, pLL,pBiMixScores] = ...
            processLabel2(data,Solutions,N,path,Correspondences,BiMixScores,GParams,RecordGraph,Labels,LL,label,frames)
        
pLabels=Labels;    
pCorr=Correspondences;
pBiMixScores=BiMixScores;
pSolutions=Solutions;
pRecordGraph=RecordGraph;
ppath=path;
pLL=LL;

maxf=frames(label,2);
minf=frames(label,1);

for f=minf:maxf % go over all the cluster's frames and delete the solution
    if(sum(cellfun('isempty',pSolutions(f,:))==0)>1)
        pSolutions{f,ppath(f)}=[];
        pLL(f,ppath(f))=-inf;
    end
end

ppath = calc_mix_Viterbi(pLL,pBiMixScores,GParams);

[ pLabels,  pRecordGraph ]=prepareUnitedLabels(data,pSolutions,N,ppath,pCorr,GParams);
