%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%    Copyright (C) 2004 Adam Spiro and Aharon Bar-Hillel
%    An implementation of a spike sorting algorithm according to the paper:
%    "Spike Sorting: Bayesian Clustering of Non-Stationary Data" 
%    by Aharon Bar-Hillel, Adam Spiro and Eran Stark 
%    (http://www.cs.huji.ac.il/~aharonbh/papers/SpikeSort_NIPS04.ps)
%
%    This program is free software; you can redistribute it and/or modify
%    it under the terms of the GNU General Public License as published by
%    the Free Software Foundation; either version 2 of the License, or
%    (at your option) any later version.
%
%    This program is distributed in the hope that it will be useful,
%    but WITHOUT ANY WARRANTY; without even the implied warranty of
%    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
%    GNU General Public License for more details.
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

% this function goes over a solutions array and reordred each MOG solution
% such that the last model will be the background model

function Solutions=reorderBackGround(Solutions)

disp('Reordering Solutions background');

[ T, N]=size(Solutions);

 for j=1:T
     for i=1:N
         if ~isempty(Solutions{j,i})
             if (size(Solutions{j,i}(1,:),2)==3)
                 Solutions{j,i}{1,4}=0;
             end
              tSolution=Solutions{j,i};
              bg=find(cellfun('isempty',tSolution(:,4))==1); % the background model index
              tmpK=size(tSolution,1);
              Solutions{j,i}=tSolution(  [ bg' setdiff(1:tmpK,bg)],:);
         end
     end
 end
 