%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%    Copyright (C) 2004 Adam Spiro and Aharon Bar-Hillel
%    An implementation of a spike sorting algorithm according to the paper:
%    "Spike Sorting: Bayesian Clustering of Non-Stationary Data" 
%    by Aharon Bar-Hillel, Adam Spiro and Eran Stark 
%    (http://www.cs.huji.ac.il/~aharonbh/papers/SpikeSort_NIPS04.ps)
%
%    This program is free software; you can redistribute it and/or modify
%    it under the terms of the GNU General Public License as published by
%    the Free Software Foundation; either version 2 of the License, or
%    (at your option) any later version.
%
%    This program is distributed in the hope that it will be useful,
%    but WITHOUT ANY WARRANTY; without even the implied warranty of
%    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
%    GNU General Public License for more details.
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

function varargout = simpleGUI(varargin)
% SIMPLEGUI M-file for simpleGUI.fig
%      SIMPLEGUI, by itself, creates a new SIMPLEGUI or raises the existing
%      singleton*.
%
%      H = SIMPLEGUI returns the handle to a new SIMPLEGUI or the handle to
%      the existing singleton*.
%
%      SIMPLEGUI('CALLBACK',hObject,eventData,handles,...) calls the local
%      function named CALLBACK in SIMPLEGUI.M with the given input arguments.
%
%      SIMPLEGUI('Property','Value',...) creates a new SIMPLEGUI or raises the
%      existing singleton*.  Starting from the left, property value pairs are
%      applied to the GUI before simpleGUI_OpeningFunction gets called.  An
%      unrecognized property name or invalid value makes property application
%      stop.  All inputs are passed to simpleGUI_OpeningFcn via varargin.
%
%      *See GUI Options on GUIDE's Tools menu.  Choose "GUI allows only one
%      instance to run (singleton)".
%
% See also: GUIDE, GUIDATA, GUIHANDLES

% Edit the above text to modify the response to help simpleGUI

% Last Modified by GUIDE v2.5 05-Apr-2004 17:12:08

% Begin initialization code - DO NOT EDIT
gui_Singleton = 1;
gui_State = struct('gui_Name',       mfilename, ...
    'gui_Singleton',  gui_Singleton, ...
    'gui_OpeningFcn', @simpleGUI_OpeningFcn, ...
    'gui_OutputFcn',  @simpleGUI_OutputFcn, ...
    'gui_LayoutFcn',  [] , ...
    'gui_Callback',   []);
if nargin & isstr(varargin{1})
    gui_State.gui_Callback = str2func(varargin{1});
end

if nargout
    [varargout{1:nargout}] = gui_mainfcn(gui_State, varargin{:});
else
    gui_mainfcn(gui_State, varargin{:});
end
% End initialization code - DO NOT EDIT

% --- Executes just before simpleGUI is made visible.
function simpleGUI_OpeningFcn(hObject, eventdata, handles, varargin)
% This function has no output args, see OutputFcn.
% hObject    handle to figure
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
% varargin   command line arguments to simpleGUI (see VARARGIN)

% Choose default command line output for simpleGUI
handles.output = hObject;

% Update handles structure
guidata(hObject, handles);

if strcmp(get(hObject,'Visible'),'off')
    initialize_gui(hObject, handles);
end

% UIWAIT makes simpleGUI wait for user response (see UIRESUME)
% uiwait(handles.figure1);


% --- Outputs from this function are returned to the command line.
function varargout = simpleGUI_OutputFcn(hObject, eventdata, handles)
% varargout  cell array for returning output args (see VARARGOUT);
% hObject    handle to figure
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Get default command line output from handles structure
varargout{1} = handles.output;

function initialize_gui(fig_handle, handles)


global data;
global time;
global Labels;
global GParams;
global box;
global k;
global fig;
global plot_type;
global titles;

k=1;
indL=find(Labels(3,:)==1);
t=setdiff(1:size(data,1),indL);
box=[ min(data(t,1)), max(data(t,1)) , min(data(t,2)), max(data(t,2)) ];
range=[ box(2)-box(1), box(4)-box(3) ];
%box=box+[ -range(1)/20 , range(1)/20 , -range(2)/20 , range(2)/20 ];
box=[ min(data(:,1)), max(data(:,1)) , min(data(:,2)), max(data(:,2)) ];

fig=figure;

if (GParams.UseConstWindowSizeFlag)
    Inds=1:GParams.SIW(1);
else
    Inds=find(time>(k-1)*GParams.TimeWin & time<k*GParams.TimeWin); 
end
if plot_type==1
    plotSpikes2( data(Inds,:), Labels(3,Inds) ,box,fig,max(Labels(3,:)) );
    title(['Time frame ' int2str(k)]);    
else
    titles{3}=sprintf('HMM time frame %d',k);
    present_clusterings2(data(Inds,:),Labels(:,Inds) ,fig,box, titles, GParams,max(Labels'));
end
figure(1);

% --- If Enable == 'on', executes on mouse press in 5 pixel border.
% --- Otherwise, executes on mouse press in 5 pixel border or over pushbutton7.
function pushbutton7_ButtonDownFcn(hObject, eventdata, handles)
% hObject    handle to pushbutton7 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)


% --- Executes on button press in pushbutton7.
function pushbutton7_Callback(hObject, eventdata, handles)
% hObject    handle to pushbutton7 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

global data;
global time;
global Labels;
global GParams;
global box;
global k;
global fig;
global plot_type;
global titles;


if  k<GParams.WinNum
    k = k+1;
	if (GParams.UseConstWindowSizeFlag)
        Inds=sum(GParams.SIW(1:k-1))+1 : sum(GParams.SIW(1:k));
	else
        Inds=find(time>(k-1)*GParams.TimeWin & time<k*GParams.TimeWin); 
	end
    if plot_type==1
        plotSpikes2( data(Inds,:), Labels(3,Inds) ,box,fig,max(Labels(3,:)) );
        title(['Time frame ' int2str(k)]);    
    else
        titles{3}=sprintf('HMM time frame %d',k);
        present_clusterings2(data(Inds,:),Labels(:,Inds),fig,box,titles,GParams,max(Labels'));
    end
    figure(1);
end


% --- Executes on button press in pushbutton8.
function pushbutton8_Callback(hObject, eventdata, handles)
% hObject    handle to pushbutton8 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

global data;
global time;
global Labels;
global GParams;
global box;
global k;
global fig;
global plot_type;
global titles;

if k~=1
    k = k-1;
	if (GParams.UseConstWindowSizeFlag)
        Inds=sum(GParams.SIW(1:k-1))+1 : sum(GParams.SIW(1:k));
	else
        Inds=find(time>(k-1)*GParams.TimeWin & time<k*GParams.TimeWin); 
    end
    if plot_type==1
        plotSpikes2( data(Inds,:), Labels(3,Inds) ,box,fig,max(Labels(3,:)) );
        title(['Time frame ' int2str(k)]);   
    else
        titles{3}=sprintf('HMM time frame %d',k);
        present_clusterings2(data(Inds,:),Labels(:, Inds),fig,box,titles,GParams,max(Labels'));
    end
    figure(1);
end